package com.steerinfo.inPlantNavigation.service.impl;


import com.steerinfo.inPlantNavigation.mapper.MapVertexEdgeMapper;
import com.steerinfo.inPlantNavigation.model.IPMMSVertexEdge;
import com.steerinfo.inPlantNavigation.model.MapVertex;
import com.steerinfo.inPlantNavigation.model.MapVertexEdge;
import com.steerinfo.inPlantNavigation.service.IMapVertexEdgeService;
import com.steerinfo.inPlantNavigation.util.ExcelIOUtil;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * MapVertexEdge服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-04-28 09:07
 * 类描述
 * 修订历史：
 * 日期：2022-04-28
 * 作者：generator
 * 参考：
 * 描述：MapVertexEdge服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "mapVertexEdgeService")
public class MapVertexEdgeServiceImpl implements IMapVertexEdgeService {

    @Autowired
    private MapVertexEdgeMapper mapVertexEdgeMapper;


    @Override
    public int importVertexEdge(String filePath) throws IOException {
        filePath="C://Users//liyunguang//Desktop//达钢测绘边数据.xls";
        List<HSSFRow> rows= ExcelIOUtil.getRowsByXls("C://Users//liyunguang//Desktop//达钢测绘边数据.xls",1);
        System.out.println("读取Excel完成，共"+rows.size()+"行");
        Map<String, List<IPMMSVertexEdge>> vertexEdgeList=new HashMap<>();
        ArrayList<MapVertexEdge> arrayList=new ArrayList<>();
        String nowOutId=null;//现在的起点
        if(rows.get(0).getCell(1)!=null && !rows.get(0).getCell(1).equals("")){
            nowOutId=rows.get(0).getCell(1).toString();//初始化第一个起点
        }else{
            return 0;
        }
        for(HSSFRow row: rows){
            if(row.getCell(0)==null || row.getCell(0).equals("")){
                continue;
            }
            //创建一个边 添加到list中去
            MapVertexEdge edge=new MapVertexEdge();
            edge.setVertexedgeId(new BigDecimal(row.getCell(0).toString()));
            edge.setOutvertexId(new BigDecimal(row.getCell(1).toString()));
            edge.setInvertexId(new BigDecimal(row.getCell(3).toString()));
            edge.setWeigh(new BigDecimal(row.getCell(5).toString()));//表格中有小数，数据会只保留整数
            arrayList.add(edge);
            System.out.println(edge);
        }
        return mapVertexEdgeMapper.batchInsert(arrayList);
    }

    @Override
    public List<MapVertexEdge> findAllAvailable() {
        return mapVertexEdgeMapper.findAllAvailable();
    }

    @Override
    public Map<String, List<MapVertexEdge>> initVertexEdge() {
        List<MapVertexEdge> edges=mapVertexEdgeMapper.findAllAvailable();//数据库查询所有可用边，不包含不可用顶点为入点的边
        Map<String,List<MapVertexEdge>> vertexEdgeList=new HashMap<>();
        for(MapVertexEdge edge:edges){
           if(vertexEdgeList.containsKey(edge.getOutvertexId().toString())){
               vertexEdgeList.get(edge.getOutvertexId().toString()).add(edge);
           }else{
               List<MapVertexEdge> arrayList= new ArrayList<>();
               arrayList.add(edge);
               vertexEdgeList.put(edge.getOutvertexId().toString(),arrayList);
           }
        }
        return vertexEdgeList;
    }

}
